#ifndef DISPATCH_PROXY_H
#define DISPATCH_PROXY_H

#include "stdafx.h"

#include <oaidl.h>
#include <string>

class CDispatchProxy:
    public CComObjectRootEx<CComSingleThreadModel>,
    public IDispatch
{
public:

    CDispatchProxy();
    virtual ~CDispatchProxy();

    BEGIN_COM_MAP(CDispatchProxy)
        COM_INTERFACE_ENTRY(IDispatch)
    END_COM_MAP()

    // IDispatch methods
    STDMETHOD(GetTypeInfoCount)(UINT* pctinfo);
    STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo** pptinfo);
    STDMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames,
        LCID lcid, DISPID* rgdispid);
    STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid,
        LCID lcid, WORD wFlags, DISPPARAMS* pdispparams, VARIANT* pvarResult,
        EXCEPINFO* pexcepinfo, UINT* puArgErr);

    // other public methods
    void setDisaptcher(IDispatch *pDispatch);

    static IDispatch* createNewDispatchProxy(IDispatch *pDispatch, std::string patchedName);

private:
    std::string getNameById(LCID lcid, DISPID id);
    

protected:
    CComPtr<IDispatch> _pDispatch;
    std::string _patchedName;

}; // CDispatchProxy

typedef CComObject<CDispatchProxy> dispatchProxy_t;

#endif // DISPATCH_PROXY_H